﻿@model eCommerce.Services.Model.Exchange
@using eCommerce.Services.Model
@using eCommerce.Services.Model.Enums
@{
    ViewBag.Title = "Cambio";
    Layout = "~/Views/Shared/_Layout.cshtml";

    List<Stock> stocks = null;
    if (TempData["Stocks"] != null)
    {
        stocks = (List<Stock>)TempData["Stocks"];
    }
}

<style>
    .input-group-addon {
        padding: 0 4px;
    }

    .form-control {
        padding: 6px 6px;
    }
</style>

<div class="page-header">
    <h1 class="page-title">Cambio</h1>
</div>

<div class="page-content">
    <div class="panel">
        <div class="panel-body">
            <div class="col-md-12">
                <div id="example">
                    @using (Html.BeginForm("ExchangeUpdate", "Exchanges", FormMethod.Post, new { @class = "validation", @autocomplete = "off" }))
                    {
                        <div class="row">
                            <div class="form-group col-sm-3">
                                <label class="control-label">Fecha</label>
                                <div class="input-group">
                                    <span class="input-group-addon">
                                        <i class="icon wb-calendar" aria-hidden="true"></i>
                                    </span>
                                    <input type="text" class="form-control" name="Created" value="@(Model.Created.HasValue && Model.Created != DateTime.MinValue ? Model.Created.Value.ToShortDateString() : DateTime.Today.ToShortDateString())" data-plugin="datepicker" />
                                </div>
                            </div>
                            <div class="form-group col-sm-4">
                                <label class="control-label">Cliente</label>
                                <select class="form-control" name="CustomerId" id="CustomerId" data-plugin="select2">
                                    <option value="@string.Empty"></option>
                                    @if (TempData["Customers"] != null)
                                    {
                                        foreach (var item in (SelectList)TempData["Customers"])
                                        {
                                            <option value="@item.Value" selected="@item.Selected">@item.Text</option>
                                        }
                                    }
                                </select>
                            </div>
                            <div class="form-group col-sm-2">
                                <label class="control-label">Lista de Precios</label>
                                <select class="form-control" name="PriceList" id="PriceListId" data-plugin="select2">
                                    <option value="@((int)PriceListEnum.Minorista)" selected="@(Model.PriceList == (int)PriceListEnum.Minorista)">Minorista</option>
                                    <option value="@((int)PriceListEnum.Mayorista)" selected="@(Model.PriceList == (int)PriceListEnum.Mayorista)">Mayorista</option>
                                    <option value="@((int)PriceListEnum.Distribuidor)" selected="@(Model.PriceList == (int)PriceListEnum.Distribuidor)">Distribuidor</option>
                                </select>
                            </div>
                            <div class="form-group col-sm-3">
                                <label class="control-label">Deposito</label>
                                <select class="form-control" name="DepositId" id="DepositId" data-plugin="select2">
                                    <option value="@string.Empty"></option>
                                    @if (TempData["Deposits"] != null)
                                    {
                                        foreach (var item in (SelectList)TempData["Deposits"])
                                        {
                                            <option value="@item.Value" selected="@item.Selected">@item.Text</option>
                                        }
                                    }
                                </select>
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="control-label">Observaciones Generales</label>
                            <textarea class="form-control" name="Observation" rows="2">@Model.Observation</textarea>
                        </div>
                        
                        <div class="form-group">
                            <div class="row">
                                <div class="col-sm-6">
                                    <h4>Detalle del Cambio</h4>
                                </div>
                                <div class="col-sm-6">
                                    <div class="text-right">
                                        <h4>Lista de Precios: <span id="PriceList">  @(Model.Customer != null ? ((PriceListEnum)Model.Customer.PriceList).ToString() : "- Ingrese un Cliente -")</span></h4>
                                        <input type="hidden" id="CustomerPriceList" value="@(Model.Customer != null ? Model.Customer.PriceList.ToString() : "1")" />
                                    </div>
                                </div>
                            </div>

                            <table class="table table-bordered table-hover table-striped" id="productsTable">
                                <thead>
                                    <tr>
                                        <th class="col-sm-4">Código de Producto</th>
                                        <th class="col-sm-1 text-center">Talle</th>
                                        <th class="col-sm-2 text-center">Color</th>
                                        <th class="col-sm-2 text-center">Tipo de Operación</th>
                                        <th class="col-sm-1 text-center">Cantidad</th>
                                        <th class="col-sm-1 text-center">Precio U.</th>
                                        <th class="text-center"></th>
                                    </tr>
                                </thead>
                                <tbody>

                                @{int i = 1;}
                                @foreach (var item in Model.ExchangeDetails)
                                {
                                    <tr>
                                        <td>
                                            <select class="form-control" name="ProductId_@i" id="ProductId_@i" data-plugin="select2" onchange="GetSizes('@i');" style="max-width:400px !important;">
                                                @if (TempData["Products"] != null)
                                                {
                                                    var prod = ((SelectList)TempData["Products"]).FirstOrDefault(x => x.Value == item.ProductId.ToString());
                                                    <option value="@prod.Value" selected="selected">@prod.Text</option>
                                                }
                                            </select>
                                        </td>
                                        <td>
                                            <select class="form-control select-required" name="SizeId_@i" id="SizeId_@i" data-plugin="select2" onchange="GetColors('@i');" style="max-width:400px !important;">
                                                @if (TempData["Sizes"] != null)
                                                {
                                                    var size = ((SelectList)TempData["Sizes"]).FirstOrDefault(x => x.Value == item.SizeId.ToString());
                                                    <option value="@size.Value" selected="selected">@size.Text</option>
                                                }
                                            </select>
                                        </td>
                                        <td>
                                            <select class="form-control select-required" name="ColorId_@i" id="ColorId_@i" data-plugin="select2" onchange="GetPrice('@i');" style="max-width:400px !important;">
                                                @if (TempData["Colors"] != null)
                                                {
                                                    var color = ((SelectList)TempData["Colors"]).FirstOrDefault(x => x.Value == item.ColorId.ToString());
                                                    <option value="@color.Value" selected="selected">@color.Text</option>
                                                }
                                            </select>
                                        </td>
                                        <td>
                                            <select class="form-control select-required" name="ExchangeDetailTypeId_@i" id="ExchangeDetailTypeId_@i" data-plugin="select2" style="max-width:400px !important;">
                                                @if (TempData["ExchangeDetailTypes"] != null)
                                                {
                                                    var type = ((SelectList)TempData["ExchangeDetailTypes"]).FirstOrDefault(x => int.Parse(x.Value) == item.ExchangeDetailTypeId);
                                                    <option value="@type.Value" selected="selected">@type.Text</option>
                                                }
                                            </select>
                                        </td>
                                        <td>
                                            <input type="text" name="Quantity_@i" id="Quantity_@i" class="form-control input-block text-right text-required" value="@item.Quantity" />                                            
                                        </td>
                                        <td>
                                            <div class="input-group">
                                                <span class="input-group-addon">$</span>
                                                <input type="text" name="Price_@i" id="Price_@i" class="form-control input-block text-right text-required" value="@item.Price" />
                                            </div>
                                            <input type="hidden" name="ExchangeDetailId_@i" value="@item.ExchangeDetailId">
                                        </td>
                                        <td class="actions text-center vertical-align" style="justify-content: center;vertical-align: middle;">
                                            <a href="javascript:void(0);" class="btn btn-sm btn-icon btn-pure btn-default on-default remove-row" data-ExchangeDetailId="@item.ExchangeDetailId" data-toggle="tooltip" data-original-title="Borrar"><i class="icon wb-trash" aria-hidden="true"></i></a>
                                        </td>
                                    </tr>
                                    i++;

                                    }
                                </tbody>
                                <tfoot>
                                    <tr class="active">
                                        <td class="text-right bold" colspan="5" style="font-weight:bold;vertical-align:middle;">TOTAL</td>
                                        <td>
                                            <div class="input-group">
                                                <span class="input-group-addon">$</span>
                                                <input type="text" class="form-control text-right" id="Total" placeholder="0,00" value="@string.Format("{0:0.00}",Model.Amount)" readonly>
                                            </div>
                                        </td>
                                        <td></td>
                                    </tr>
                                    <tr class="active">
                                        <td colspan="7">
                                            <button id="addToTable" class="btn btn-outline btn-primary" type="button">
                                                <i class="icon wb-plus" aria-hidden="true"></i> Agregar Producto
                                            </button>
                                        </td>
                                    </tr>
                                </tfoot>
                                </table>
                            </div>
                            <div class="row form-group text-right">
                                <button class="btn btn-primary btn-success" id="btnSave">Grabar</button>
                                <button class="btn btn-default" onclick="window.location = '/Exchanges';">Cancelar</button>
                                @Html.HiddenFor(model => model.ExchangeId)
                                <input type="hidden" id="DeletedItems" name="DeletedItems" />
                            </div>
                    }
                </div>
            </div>
        </div>
    </div>
</div>

@section Scripts {

    <script type="text/javascript">

        $(document).ready(function () {
            //Datos Orden
            $('.validation').formValidation({
                framework: "bootstrap",
                button: {
                    selector: '#btnSave',
                    disabled: 'disabled'
                },
                icon: null,
                fields: {
                    Created: {
                        validators: {
                            notEmpty: {
                                message: 'El campo Fecha es requerido.'
                            }
                        }
                    },
                    CustomerId: {
                        validators: {
                            notEmpty: {
                                message: 'El campo Cliente es requerido.'
                            }
                        }
                    },
                    DepositId: {
                        validators: {
                            notEmpty: {
                                message: 'El campo Deposito es requerido.'
                            }
                        }
                    }
                }
            });

        });

        $(document).ready(function ()
        {
            $("#addToTable").click(function ()
            {
                if ($("#CustomerId").val() != '')
                {
                    var row_number = $("#productsTable tr").length;

                    var row = [
                        '<tr>',
                            '<td><select style="max-width:400px;" class="form-control" name="ProductId_' + row_number + '" id="ProductId_' + row_number + '" data-plugin="select2" onchange="GetSizes(' + row_number + ');"><option value=""></option></select></td>',
                            '<td><select style="max-width:400px;" class="form-control select-required" name="SizeId_' + row_number + '" id="SizeId_' + row_number + '" data-plugin="select2" onchange="GetColors(' + row_number + ');"><option value=""></option></select></td>',
                            '<td><select style="max-width:400px;" class="form-control select-required" name="ColorId_' + row_number + '" id="ColorId_' + row_number + '" data-plugin="select2" onchange="GetPrice(' + row_number + ');"><option value=""></option></select></td>',
                            '<td><select style="max-width:400px;" class="form-control select-required" name="ExchangeDetailTypeId_' + row_number + '" id="ExchangeDetailTypeId_' + row_number + '" data-plugin="select2"><option value=""></option></select></td>',
                            '<td>',
                                '<input type="text" name="Quantity_' + row_number + '" id="Quantity_' + row_number + '" class="form-control input-block text-right text-required" placeholder="0" />',                                
                            '</td>',
                            '<td>',
                                '<div class="input-group">',
                                '<span class="input-group-addon">$</span>',
                                '<input type="text" name="Price_' + row_number + '" id="Price_' + row_number + '" class="form-control input-block text-right text-required" />',
                                '</div>',
                                '<input type="hidden" name="ExchangeDetailId_' + row_number + '" value="-1">',
                            '</td>',
                            '<td class="actions text-center vertical-align" style="justify-content: center;vertical-align: middle;"><a href="javascript:void(0);" class="btn btn-sm btn-icon btn-pure btn-default on-default remove-row" data-toggle="tooltip" data-original-title="Borrar"><i class="icon wb-trash" aria-hidden="true"></i></a>',
                            '<input type="hidden" id="Stock_' + row_number + '" name="Stock_' + row_number + '" /></td>',
                        '</tr>'
                    ].join(' ');

                    $("#productsTable").append(row);

                    var products = $("#ProductId_" + row_number);
                    GetProducts(products);

                    var exchangeTypes = $("#ExchangeDetailTypeId_" + row_number);
                    GetExchangeDetailTypes(exchangeTypes);

                    $("#ProductId_" + row_number).select2();
                    $("#SizeId_" + row_number).select2();
                    $("#ColorId_" + row_number).select2();
                    $("#ExchangeDetailTypeId_" + row_number).select2();
                }
                else
                {
                    toastr.warning("Primero debe seleccionar un Cliente.")
                }
            });

            $("#productsTable").on('click', '.remove-row', function () {
                var item = $(this);
                var exchangeDetailId = $(this).attr("data-ExchangeDetailId");

                updateDeletedItems(exchangeDetailId)
                $(this).parent().parent().remove();
                setSubTotal();
            });

            if ($("#OrderId").val() > 0)
                setSubTotal();

            $("#CustomerId").change(function () {
                var customerId = $(this).val();
                if (customerId == '') {
                    $("#PriceList").text("- Ingrese un Cliente -")
                }
                else {
                    GetCustomerPriceList(customerId);
                }
            });

            $("#PriceListId").change(function () {
                $("#PriceList").text($("#PriceListId option:selected").text());
                $("#CustomerPriceList").val($("#PriceListId option:selected").val());

            });

            $("table").on('change', "[id^='Quantity_'],[id^='Price_']", function () {
                SetTotal();
            });

            SetTotal();
        });

        function SetTotal()
        {
            var total = 0;
            $("[id^=Quantity_]").each(function ()
            {
                var row_number = parseInt($(this).attr("id").split("_")[1]);
                var quantity = parseFloat($(this).val().replace(',', '.'));
                var price = parseFloat($("#Price_" + row_number).val().replace(',', '.'));
                var operation_type = $("#ExchangeDetailTypeId_" + row_number).val();

                if (operation_type == "@((int)ExchangeDetailTypeEnum.Ingreso)") {
                    total -= price * quantity;
                } else {
                    total += price * quantity;
                }
            });

            $("#Total").val(total.toFixed(2));
        }

        function GetCustomerPriceList(customerId) {
            $.ajax({
                type: "GET",
                cache: false,
                url: "/Orders/GetCustomerPriceList",
                data: { CustomerId: customerId },
                success: function (data) {
                    $("#PriceList").text(data.Name)
                    $("#CustomerPriceList").val(data.PriceList);
                    $("#PriceListId").val(data.PriceList).trigger("change");
                }
            });
        }
        function updateDeletedItems(exchangeDetailId)
        {
            if (exchangeDetailId != "-1")
            {
                var ids = $("#DeletedItems").val();
                $("#DeletedItems").val(ids + exchangeDetailId + ",");
            }
        }

        function GetExchangeDetailTypes(control)
        {
            $.ajax({
                type: "GET",
                cache: false,
                url: "/Exchanges/GetExchangeDetailTypes",
                data: $(this).serializeArray(),
                success: function (data)
                {
                    control.empty();
                    control.append($('<option value=""></option>'));
                    $.each(data, function (index, item) {
                        control.append($('<option value=' + item.TransactionTypeId + '>' + item.Description + '</option>'));
                    });
                }
            });
        }

        function GetProducts(control)
        {
            $.ajax({
                type: "GET",
                cache: false,
                url: "/Products/GetProductsToSale",
                data: $(this).serializeArray(),
                success: function (data)
                {
                    control.empty();
                    control.append($('<option value=""></option>'));
                    $.each(data, function (index, item) {
                        control.append($('<option value=' + item.ProductId + '>' + item.Code + ' - ' + item.Title + '</option>'));
                    });
                }
            });
        }

        function GetSizes(row_number)
        {
            if ($("#ProductId_" + row_number).val() != '')
            {
                $.ajax({
                    type: "GET",
                    cache: false,
                    url: "/Products/GetProductSizesToSale",
                    data: { ProductId: $("#ProductId_" + row_number).val() },
                    success: function (data)
                    {
                        control = $("#SizeId_" + row_number);
                        control.empty();
                        control.select2();
                        control.append($('<option value=""></option>'));

                        $.each(data, function (index, item) {
                            control.append($('<option value=' + item.SizeId + '>' + item.Description + '</option>'));
                        });

                        control = $("#ColorId_" + row_number);
                        control.empty();
                        control.select2();

                        cleanRowData(row_number);
                    }
                });
            }
            else
            {
                toastr.warning("Debe seleccionar un Producto.");
            }
        }

        function cleanRowData(row_number) {
            $("#Price_" + row_number).val("");
        }

        function GetColors(row_number)
        {
            $.ajax({
                type: "GET",
                cache: false,
                url: "/Products/GetProductColorsToSale",
                data: { ProductId: $("#ProductId_" + row_number).val(), SizeId: $("#SizeId_" + row_number).val() },
                success: function (data)
                {
                    control = $("#ColorId_" + row_number);
                    control.empty();
                    control.select2();

                    control.append($('<option value=""></option>'));
                    $.each(data, function (index, item) {
                        control.append($('<option value=' + item.ColorId + '>' + item.Description + '</option>'));
                    });

                    cleanRowData(row_number);
                }
            });
        }

        function GetPrice(row_number) {
            $.ajax({
                type: "GET",
                cache: false,
                url: "/Products/GetProductInfoToSale",
                data: { ProductId: $("#ProductId_" + row_number).val(), SizeId: $("#SizeId_" + row_number).val(), ColorId: $("#ColorId_" + row_number).val(), PriceList: $("#CustomerPriceList").val() },
                success: function (data) {
                    control = $("#Price_" + row_number);
                    control.val(data.CustomerPrice);                    
                }
            });
        }
    </script>
}

